import { MonthOrYearComponents, State } from './store';
import { CreateElement, CreateElementOptions, eventHandler } from './utils';
import { _EventListener } from "./utils";
import { DatepickerType, DateType, MonthType, YearType } from "./options";
import { Sub } from "./observer";
export declare type HeaderType = 'start' | 'end';
export declare type ComponentsName = 'month' | 'year';
export declare type RangeComponentName = ComponentsName | 'date';
export interface createMonthOrYearComponentsFunction {
    (state: State, t: HeaderType): Node;
}
export interface UpdateCbType {
    text: (res: string) => void;
    cls: (res: string) => void;
    style: (res: string) => void;
}
export declare type PopoverType = DatepickerType<(CreateElementOptions | CreateElement)[]>;
export declare type DayEvent = DateType<(this: State) => void, _EventListener[]>;
export declare type MonthEvent = MonthType<(this: State) => void, _EventListener[]>;
export declare type YearEvent = YearType<(this: State) => void, _EventListener[]>;
export interface RangeClickEvent {
    complete: {
        plt: HeaderType;
        status: 'selecting';
    };
    selecting: {
        plt: HeaderType;
        status: 'complete';
    };
}
export interface CreateMonthOrYearComponentsOptions {
    month: {
        listener: (child: MonthOrYearComponents, state: State) => eventHandler;
        children: (idx: number) => (CreateElementOptions | CreateElement)[];
    };
    year: {
        listener: (child: MonthOrYearComponents, state: State) => eventHandler;
        children: (idx: number) => (CreateElementOptions | CreateElement)[];
    };
}
export interface HeaderDateComponentsType {
    date: Sub<string>;
    year: Sub<string>;
    month: Sub<string>;
}
